# coding: UTF-8
# -*- coding: utf-8 -*-
# Copyright under  the latest Apache License 2.0

import os
import wsgiref.handlers
import urlparse
import base64
import logging
import re
from cgi import parse_qsl
from google.appengine.ext import webapp
from google.appengine.ext import db
from google.appengine.api import users
from google.appengine.api import urlfetch
from google.appengine.api import urlfetch_errors
from google.appengine.ext.webapp import util
from google.appengine.ext.webapp import template
from wsgiref.util import is_hop_by_hop
from uuid import uuid4
import oauth
import xml.etree.ElementTree as etree

filteredtwiproxy_version = '0.1'
gtap_version = '0.4'

CONSUMER_KEY = '5wmGWiODBmJ34cWqsdxHA'
CONSUMER_SECRET = 'JyVtJB2as09hbGmnEIQcQRtKfxnVpCPm27L3r7JWo'

ENFORCE_GZIP = True

gtap_message = """
    <html>
        <head>
        <title>GAE Twitter API Proxy</title>
        <link href='https://appengine.google.com/favicon.ico' rel='shortcut icon' type='image/x-icon' />
        <style>body { padding: 20px 40px; font-family: Verdana, Helvetica, Sans-Serif; font-size: medium; }</style>
        </head>
        <body><h2>filtered-twiproxy v0.1 is running!</h2></p>
        <p><a href="/config">[Config Home]</a></p>
        <p><a href='/oauth/session'><img src='/static/sign-in-with-twitter.png' border='0'></a> <== Need Fuck GFW First!! 
        or <a href='/oauth/change'>change your key here</a></p>
        <p>This is a simple solution on Google App Engine which can proxy the HTTP request to twitter's official REST API url.</p>
        <p><font color='red'><b>Don't forget the \"/\" at the end of your api proxy address!!!.</b></font></p>
        <p>filtered-twiproxy is based on <a href="http://code.google.com/p/twiproxy/">twiproxy</a> and <a href="http://code.google.com/p/gtap/">GTAP v0.4.</a></p>
        <p>Modified by <a href="http://twitter.com/hitoriblog">@hitoriblog</a></p>
    </body></html>
    """

class Keyword(db.Model):
    owner = db.UserProperty()
    content = db.StringProperty()
    isregexp = db.BooleanProperty(default=False)

class ScreenName(db.Model):
    owner = db.UserProperty()
    content = db.StringProperty()
    isregexp = db.BooleanProperty(default=False)

class ClientName(db.Model):
    owner = db.UserProperty()
    content = db.StringProperty()
    isregexp = db.BooleanProperty(default=False)

class MenuHandler(webapp.RequestHandler):
    def get(self):
        if users.get_current_user():
            path = os.path.join(os.path.dirname(__file__), 'templates/config.html')
            logout_url = users.create_logout_url(self.request.uri)
            self.response.out.write(
                template.render(path, {'logout_url' : logout_url}))
        else:
            self.redirect(users.create_login_url(self.request.uri))

class KeywordHandler(webapp.RequestHandler):
    def get(self):
        if users.get_current_user():
            self.list_keyword()
        else:
            self.redirect(users.create_login_url(self.request.uri))

    def list_keyword(self):
        keywords = Keyword.all().filter(
            "owner =", users.get_current_user())
        path = os.path.join(os.path.dirname(__file__), 'templates/keyword.html')
        logout_url = users.create_logout_url(self.request.uri)
        self.response.out.write(
            template.render(path, {'keywords' : keywords,
                                   'logout_url' : logout_url}))

class KeywordAddHandler(webapp.RequestHandler):
    #def get(self):
    #    path = os.path.join(os.path.dirname(__file__), 'templates/keyword_add.html')
    #    self.response.out.write(template.render(path, {}))

    def post(self):
        keyword = Keyword()
        keyword.owner = users.get_current_user()
        keyword.content = self.request.get('content')
        keyword.isregexp = bool(self.request.get('isregexp'))
        if (keyword.content != ""):
            keyword.put()
        self.redirect('/keyword')

class KeywordDeleteHandler(webapp.RequestHandler):
    def get(self):
        keyword = db.get(db.Key(self.request.get('key')))
        keyword.delete()
        self.redirect('/keyword')

class ScreenNameHandler(webapp.RequestHandler):
    def get(self):
        if users.get_current_user():
            self.list_screen_name()
        else:
            self.redirect(users.create_login_url(self.request.uri))

    def list_screen_name(self):
        screen_names = ScreenName.all().filter(
            "owner =", users.get_current_user())
        path = os.path.join(os.path.dirname(__file__), 'templates/screen_name.html')
        logout_url = users.create_logout_url(self.request.uri)
        self.response.out.write(
            template.render(path, {'screen_names' : screen_names,
                                   'logout_url' : logout_url}))

class ScreenNameAddHandler(webapp.RequestHandler):
    #def get(self):
    #    path = os.path.join(os.path.dirname(__file__), 'templates/screen_name_add.html')
    #    self.response.out.write(template.render(path, {}))

    def post(self):
        screen_name = ScreenName()
        screen_name.owner = users.get_current_user()
        screen_name.content = self.request.get('content')
        screen_name.isregexp = bool(self.request.get('isregexp'))
        if (screen_name.content != ""):
            screen_name.put()
        self.redirect('/screen_name')

class ScreenNameDeleteHandler(webapp.RequestHandler):
    def get(self):
        screen_name = db.get(db.Key(self.request.get('key')))
        screen_name.delete()
        self.redirect('/screen_name')

class ClientNameHandler(webapp.RequestHandler):
    def get(self):
        if users.get_current_user():
            self.list_client_name()
        else:
            self.redirect(users.create_login_url(self.request.uri))

    def list_client_name(self):
        client_names = ClientName.all().filter(
            "owner =", users.get_current_user())
        path = os.path.join(os.path.dirname(__file__), 'templates/client_name.html')
        logout_url = users.create_logout_url(self.request.uri)
        self.response.out.write(
            template.render(path, {'client_names' : client_names,
                                   'logout_url' : logout_url}))

class ClientNameAddHandler(webapp.RequestHandler):
    #def get(self):
    #    path = os.path.join(os.path.dirname(__file__), 'templates/client_name_add.html')
    #    self.response.out.write(template.render(path, {}))

    def post(self):
        client_name = ClientName()
        client_name.owner = users.get_current_user()
        client_name.content = self.request.get('content')
        client_name.isregexp = bool(self.request.get('isregexp'))
        if (client_name.content != ""):
            client_name.put()
        self.redirect('/client_name')

class ClientNameDeleteHandler(webapp.RequestHandler):
    def get(self):
        client_name = db.get(db.Key(self.request.get('key')))
        client_name.delete()
        self.redirect('/client_name')

def success_output(handler, content, content_type='text/html'):
    handler.response.status = '200 OK'
    handler.response.headers.add_header('GTAP-Version', gtap_version)
    handler.response.headers.add_header('Content-Type', content_type)
    handler.response.out.write(content)

def error_output(handler, content, content_type='text/html', status=503):
    handler.response.set_status(503)
    handler.response.headers.add_header('GTAP-Version', gtap_version)
    handler.response.headers.add_header('Content-Type', content_type)
    handler.response.out.write("Gtap Server Error:<br />")
    return handler.response.out.write(content)

def compress_buf(buf):
    zbuf = StringIO.StringIO()
    zfile = gzip.GzipFile(None, 'wb', 9, zbuf)
    zfile.write(buf)
    zfile.close()
    return zbuf.getvalue()

class MainPage(webapp.RequestHandler):

    def conver_url(self, orig_url):
        (scm, netloc, path, params, query, _) = urlparse.urlparse(orig_url)
        
        path_parts = path.split('/')
        if path_parts[1] == 'api' or path_parts[1] == 'search' or path_parts[1] == 'basic' :
            sub_head = path_parts[1]
            path_parts = path_parts[2:]
            path_parts.insert(0,'')
            new_path = '/'.join(path_parts).replace('//','/')
            if 	sub_head == 'basic' :
                new_netloc = 'twitter.com'			
            else :			
                new_netloc = sub_head + '.twitter.com'
        else:
            new_path = path
            new_netloc = 'twitter.com'
    
        new_url = urlparse.urlunparse(('https', new_netloc, new_path.replace('//','/'), params, query, ''))
        logging.debug( 'new_url:' + new_url )		
        return new_url, new_path

    def parse_auth_header(self, headers, client):
        user_access_token = None
        user_access_secret = None
        protected=True       
		
        if 'Authorization' in headers :
            auth_header = headers['Authorization']
            if 'oauth_version' in auth_header :
                logging.debug("auth_header:" + auth_header)
                auth_parts = auth_header.split(',')
                for part in auth_parts :
                    if 'oauth_token' in part :
                       	in_part = part.split('=')
                        user_access_token = in_part[1].strip('"')
						
                logging.debug("user_access_token:" + user_access_token)
                user_access_token, user_access_secret  = client.get_access_from_db2( user_access_token )
                protected=True
            else :
                username = None
                password = None
                
                auth_parts = auth_header.split(' ')
                user_pass_parts = base64.b64decode(auth_parts[1]).split(':')
                username = user_pass_parts[0]
                password = user_pass_parts[1]
                
                user_access_token = None
        
                if username is None :
                    protected=False
                    user_access_token, user_access_secret = '', ''
                else:
                    protected=True
                    user_access_token, user_access_secret  = client.get_access_from_db(username, password)
                    if user_access_token is None :
                        return error_output(self, 'Can not find this user from db')
				
        return user_access_token, user_access_secret, protected

    def do_proxy(self, method):
        orig_url = self.request.url

        orig_body = self.request.body

        new_url,new_path = self.conver_url(orig_url)

        if new_path == '/' or new_path == '':
            global gtap_message
            gtap_message = gtap_message.replace('#gtap_version#', gtap_version)
            return success_output(self, gtap_message)
        
        callback_url = "%s/oauth/verify" % self.request.host_url
        client = oauth.TwitterClient(CONSUMER_KEY, CONSUMER_SECRET, callback_url)

        user_access_token, user_access_secret, protected = self.parse_auth_header(self.request.headers, client)

        additional_params = dict([(k,v) for k,v in parse_qsl(orig_body)])

        use_method = urlfetch.GET if method=='GET' else urlfetch.POST

        try :
            data = client.make_request(url=new_url, token=user_access_token, secret=user_access_secret, 
                                   method=use_method, protected=protected, 
                                   additional_params = additional_params)
        except Exception,error_message:
            logging.debug( error_message )
            error_output(self, content=error_message)
        else :
            #logging.debug(data.headers)
            self.response.headers.add_header('GTAP-Version', gtap_version)

            for res_name, res_value in data.headers.items():
                if is_hop_by_hop(res_name) is False and res_name!='status':
                    self.response.headers.add_header(res_name, res_value)

            # JSONだったらスキップ（面倒なので。Twitter for iPhoneでは検索がJSONのようです）
            if (str(orig_url).rfind(u'json?') >= 0):
                # そのまんま返却
                self.response.out.write(data.content)
            else :
                # JSONでなければXMLとしてパース
                dom = etree.fromstring(data.content)
                # Tweet毎に舐めていく
                for st in dom.findall('.//status'):
                    # clearのフラグ初期化。Trueにしたら削除
                    clear = False
                    # screen nameでフィルタ
                    for screen_name in ScreenName.all():
                        if (screen_name.isregexp):
                            regexp = re.compile(screen_name.content)
                            if (regexp.match(st.find('.//screen_name').text)):
                                # マッチしたら削除フラグ立てる
                                clear = True
                        else:
                            if (st.find('.//screen_name').text.rfind(screen_name.content) >= 0):
                                # マッチしたら削除フラグ立てる
                                clear = True
                    # 内容でフィルタ
                    for keyword in Keyword.all():
                        if (keyword.isregexp):
                            regexp = re.compile(keyword.content)
                            if (regexp.match(st.find('.//text').text)):
                                # マッチしたら削除フラグ立てる
                                clear = True
                        else:
                            if (st.find('.//text').text.rfind(keyword.content) >= 0):
                                # 内容の加工をする場合のサンプル
                                # st.find('.//text').text = '[' + st.find('.//text').text + ']'
                                # マッチしたら削除フラグ立てる
                                clear = True
                    # クライアントでフィルタ
                    for client in ClientName.all():
                        if (client.isregexp):
                            regexp = re.compile(client.content)
                            if (regexp.match(st.find('.//source').text)):
                                # マッチしたら削除フラグ立てる
                                clear = True
                        else:
                            if (st.find('.//source').text.rfind(client.content) >= 0):
                                # マッチしたら削除フラグ立てる
                                clear = True
                    if (clear):
                        # ここまでに削除フラグが立っていたらNode（Tweet）を実際に削除
                        st.clear()
                # DOMにパース、加工を済ませたものをXMLに戻して返却
                self.response.out.write('<?xml version="1.0" encoding="UTF-8"?>\n' + etree.tostring(dom))

            logging.debug( data.headers )	
            logging.debug( 'data.content:' + data.content )				

    def post(self):
        self.do_proxy('POST')
    
    def get(self):
        self.do_proxy('GET')


class OauthPage(webapp.RequestHandler):

    def get(self, mode=""):
        callback_url = "%s/oauth/verify" % self.request.host_url
        client = oauth.TwitterClient(CONSUMER_KEY, CONSUMER_SECRET, callback_url)

        if mode=='session':
            # step C Consumer Direct User to Service Provider
            try:
                url = client.get_authorization_url()
                self.redirect(url)
            except Exception,error_message:
                self.response.out.write( error_message )


        if mode=='verify':
            # step D Service Provider Directs User to Consumer
            auth_token = self.request.get("oauth_token")
            auth_verifier = self.request.get("oauth_verifier")

            # step E Consumer Request Access Token 
            # step F Service Provider Grants Access Token
            try:
                access_token, access_secret, screen_name = client.get_access_token(auth_token, auth_verifier)
                self_key = '%s' % uuid4()
                # Save the auth token and secret in our database.
                client.save_user_info_into_db(username=screen_name, password=self_key, 
                                              token=access_token, secret=access_secret)
                show_key_url = '%s/oauth/showkey?name=%s&key=%s' % (
                                                                       self.request.host_url, 
                                                                       screen_name, self_key)
                self.redirect(show_key_url)
            except Exception,error_message:
                logging.debug("oauth_token:" + auth_token)
                logging.debug("oauth_verifier:" + auth_verifier)
                logging.debug( error_message )
                self.response.out.write( error_message )
        
        if mode=='showkey' or mode=='change':
            screen_name = self.request.get("name")
            self_key = self.request.get("key")
            out_message = """
                <html><head><title>GTAP</title>
                <style>body { padding: 20px 40px; font-family: Courier New; font-size: medium; }</style>
                </head><body><p><form method="post" action="%s/oauth/changekey">
                screen name : <input type="text" name="name" size="20" value="%s"> <br /><br />
                current key : <input type="text" name="old_key" size="50" value="%s"> <br /><br />
                the new key : <input type="text" name="new_key" size="50" value=""> <br /><br />
                <input type="submit" name="_submit" value="Change the Key">
                </form></p></body></html>
                """ % (self.request.host_url, screen_name, self_key)
            self.response.out.write( out_message )
        
        if mode=='test':
            screen_name = self.request.get("name")
            self_key = self.request.get("key")
            user_access_token, user_access_secret  = client.get_access_from_db(screen_name, self_key)
            self.response.out.write( '%s<---->%s' % (user_access_token, user_access_secret) )
            
    def post(self, mode=''):
        
        callback_url = "%s/oauth/verify" % self.request.host_url
        client = oauth.TwitterClient(CONSUMER_KEY, CONSUMER_SECRET, callback_url)
		
        if mode=='access_token':
            screen_name = self.request.get("x_auth_username")
            self_key = self.request.get("x_auth_password")
            oauth_token, oauth_token_secret = client.get_access_from_db(screen_name, self_key)
            self.response.out.write( 'oauth_token=%s&oauth_token_secret=%s&user_id=153814517&screen_name=%s&x_auth_expires=0' % (oauth_token, oauth_token_secret, screen_name) )
			
        if mode=='changekey':
            screen_name = self.request.get("name")
            old_key = self.request.get("old_key")
            new_key = self.request.get("new_key")
            user_access_token, user_access_secret  = client.get_access_from_db(screen_name, old_key)
            
            if user_access_token is None or user_access_secret is None:
                logging.debug("screen_name:" + screen_name)
                logging.debug("old_key:" + old_key)
                logging.debug("new_key:" + new_key)
                self.response.out.write( 'Can not find user from db, or invalid old_key.' )
            else:
                try:
                    client.save_user_info_into_db(username=screen_name, password=new_key, 
                                                  token=user_access_token, secret=user_access_secret)
                    show_key_url = '%s/oauth/showkey?name=%s&key=%s' % (
                                                                        self.request.host_url, 
                                                                        screen_name, new_key)
                    self.redirect(show_key_url)
                except Exception,error_message:
                    logging.debug("screen_name:" + screen_name)
                    logging.debug("old_key:" + old_key)
                    logging.debug("new_key:" + new_key)
                    logging.debug( error_message )
                    self.response.out.write( error_message )

def main():
    application = webapp.WSGIApplication( [
            ('/config', MenuHandler),
            ('/keyword', KeywordHandler),
            ('/keyword_add', KeywordAddHandler),
            ('/keyword_delete', KeywordDeleteHandler),
            ('/screen_name', ScreenNameHandler),
            ('/screen_name_add', ScreenNameAddHandler),
            ('/screen_name_delete', ScreenNameDeleteHandler),
            ('/client_name', ClientNameHandler),
            ('/client_name_add', ClientNameAddHandler),
            ('/client_name_delete', ClientNameDeleteHandler),
	    (r'/basic/.*', MainPage),
        (r'/api/oauth/(.*)', OauthPage),
        (r'/api/.*', MainPage),
        (r'/search/oauth/(.*)', OauthPage),
        (r'/search/.*', MainPage),
        (r'/oauth/(.*)', OauthPage),
        (r'/.*',         MainPage)
        ], debug=True)
    wsgiref.handlers.CGIHandler().run(application)
    
if __name__ == "__main__":
  main()
